unit NetView;

interface

uses
  Windows, Messages, SysUtils, Classes,nvplugn;

type
  LPNVLINE=^NVLINE;
  TNetWatcherConnectEvent = procedure( Sender: TObject; HostId: cardinal; Flags:cardinal) of object;
  TNetWatcherDisconnectEvent = procedure( Sender: TObject; HostId: cardinal) of object;
  THostAlertEvent = procedure( Sender: TObject; HostId: cardinal) of object;
  TNetViewActivate = procedure( Sender: TObject; Activated: boolean) of object;
  TListEvent = procedure( Sender: TObject; ListId:cardinal; Flags:cardinal) of object;
  TVisualMapImageExported = procedure( Sender: TObject; ListId:cardinal) of object;
  TNetViewClose = procedure( Sender: TObject) of object;
  TNetView = class(TComponent)
  private
    { Private declarations }
  wnd:hwnd;
  protected
  FEnableEventsHandling:boolean;
  FOnHostAlertGoOnline:THostAlertEvent;
  FOnHostAlertGoOffline:THostAlertEvent;
  FOnHostAlertClicked:THostAlertEvent;
  FOnListEvent:TListEvent;
  FOnNetViewActivate:TNetViewActivate;
  FOnVisualMapImageExported:TVisualMapImageExported;
  FOnNetWatcherConnect:TNetWatcherConnectEvent;
  FOnNetWatcherDisconnect:TNetWatcherDisconnectEvent;
  FOnNetViewClose:TNetViewClose;
  procedure EventsHandler(msg:dword;wp:dword;lp:dword);
  procedure SetEnableEventsHandling(Value :boolean);
    { Protected declarations }
  public
  constructor Create(Owner: TComponent);override;
  destructor Destroy; override;
  function GetNetViewStatus(var NVMajorVersion:integer;var NVMinorVersion:integer):integer;
  function Action(wp:cardinal;lp:cardinal):cardinal;
  ////////host
  function GetHostIdByText(txt:string;flags:cardinal):cardinal;
  function GetHost(var hst:NVHOST;flags:cardinal):cardinal;
  function SetHost(var hst:NVHOST;flags:cardinal):cardinal;
  function DelHost(id:cardinal):cardinal;
  function GetMetaVar(id:cardinal;varname:string;var vardata:string):integer;
  function SetMetaVar(id:cardinal;varname:string;vardata:string):integer;
  ////////list
  function GetListIdByText(txt:string;flags:cardinal):cardinal;
  function GetList(var lst:NVLIST):cardinal;
  function SetList(var lst:NVLIST):cardinal;
  function DelList(id:cardinal):cardinal;
  ////////line
  function GetLine(var ln:NVLINE):integer;
  function SetLine(var ln:NVLINE):integer;
  function DelLine(ind:integer):integer;
  ////////area
  function GetArea(var ar:NVAREA):cardinal;
  function SetArea(var ar:NVAREA):cardinal;
  function DelArea(id:cardinal):cardinal;
    { Public declarations }
  published
  property OnNetWatcherConnect:TNetWatcherConnectEvent read FOnNetWatcherConnect write FOnNetWatcherConnect;
  property OnNetWatcherDisconnect:TNetWatcherDisconnectEvent read FOnNetWatcherDisconnect write FOnNetWatcherDisconnect;
  property OnHostAlertGoOnline:THostAlertEvent read FOnHostAlertGoOnline write FOnHostAlertGoOnline;
  property OnHostAlertGoOffline:THostAlertEvent read FOnHostAlertGoOffline write FOnHostAlertGoOffline;
  property OnHostAlertClicked:THostAlertEvent read FOnHostAlertClicked write FOnHostAlertClicked;
  property OnListEvent:TListEvent read FOnListEvent write FOnListEvent;
  property OnNetViewActivate:TNetViewActivate read FOnNetViewActivate write FOnNetViewActivate;
  property OnVisualMapImageExported:TVisualMapImageExported read FOnVisualMapImageExported write FOnVisualMapImageExported;
  property OnNetViewClose:TNetViewClose read FOnNetViewClose write FOnNetViewClose;
  property EnableEventsHandling:Boolean read FEnableEventsHandling write SetEnableEventsHandling default false;
    { Published declarations }
  end;

procedure Register;

var   NVGetNetViewStatus:function(res:dword):DWORD;stdcall;
      NVSetEventHandlerProc:function(HandlerProc:pointer):DWORD;stdcall;
      NVAction:function(res:dword;wp:dword;lp:dword):DWORD;stdcall;
      NVGetHostByTextA:function(res:dword;txt:pchar;flags:dword):DWORD;stdcall;
      NVGetHostA:function(res:dword;hst:LPNVHOST;flags:dword):DWORD;stdcall;
      NVSetHostA:function(res:dword;hst:LPNVHOST;flags:dword):DWORD;stdcall;
      NVDelHostA:function(res:dword;hst:LPNVHOST):DWORD;stdcall;
      NVGetMetaVarA:function(res:dword;hstid:dword;VarName:pchar;DataBuff:pchar;BuffSize:lpdword):DWORD;stdcall;
      NVSetMetaVarA:function(res:dword;hstid:dword;VarName:pchar;DataBuff:pchar;BuffSize:dword):DWORD;stdcall;
      NVGetListByTextA:function(res:dword;txt:pchar;flags:dword):dword;stdcall;
      NVGetListA:function(res:dword;lst:lpNVLIST):dword;stdcall;
      NVSetListA:function(res:dword;lst:lpNVLIST):dword;stdcall;
      NVDelListA:function(res:dword;lst:lpNVLIST):dword;stdcall;
      NVGetLineA:function(res:dword;Ln:LPNVLINE):DWORD;stdcall;
      NVSetLineA:function(res:dword;Ln:LPNVLINE):DWORD;stdcall;
      NVDelLineA:function(res:dword;Ln:LPNVLINE):DWORD;stdcall;
      NVGetAreaA:function(res:dword;ar:lpNVAREA):DWORD;stdcall;
      NVSetAreaA:function(res:dword;ar:lpNVAREA):DWORD;stdcall;
      NVDelAreaA:function(res:dword;ar:lpNVAREA):DWORD;stdcall;

      nvapidll:dword;
      ObjList:TList;
      HandlerEnablingCount:integer;
      crsc:_RTL_CRITICAL_SECTION;
implementation

function NetViewWndProc(hwnd:HWND;msg:dword;wp:dword;lp:dword):dword;stdcall;
var usrdata:cardinal;
begin
usrdata:=GetWindowLong(hwnd,GWL_USERDATA);
if usrdata<>0 then TNetView(usrdata).EventsHandler(msg,wp,lp);
if(msg<>WM_QUIT)then Result:=DefWindowProc(hwnd,msg,wp,lp) else Result:=1;
end;
  constructor TNetView.Create(Owner: TComponent);
  var wc:wndclass;
  begin
    inherited Create(Owner);
    zeromemory(@wc,sizeof(wc));
    wc.lpfnWndProc:=@NetViewWndProc;
    wc.cbClsExtra:=16;wc.cbWndExtra:=16;
    wc.lpszClassName:='_TNetView_events_handler_wnd_';
    wc.hInstance:=hInstance;
    Windows.RegisterClass(wc);
    wnd:=Windows.CreateWindow('_TNetView_events_handler_wnd_','_TNetView_events_handler_wnd_',0,0,0,0,0,0,0,hInstance,nil);
    SetWindowLong(wnd,GWL_USERDATA,cardinal(self));
    EnterCriticalSection(crsc);
    ObjList.Add(self);
    LeaveCriticalSection(crsc);
  end;
  destructor TNetView.Destroy;
  begin
  SetEnableEventsHandling(false);
  EnterCriticalSection(crsc);
  ObjList.Remove(self);
  LeaveCriticalSection(crsc);
  DestroyWindow(wnd);
  inherited Destroy;
  end;

  function TNetView.GetNetViewStatus(var NVMajorVersion:integer;var NVMinorVersion:integer):integer;
  var ret:dword;
  begin
  if nvapidll=0 then
  begin
  MessageBox(0,'Can''t load NVAPI.dll. You must download and install latest NetView version from http://www.killprog.com.','Initialization error',MB_ICONERROR);
  ret:=0;
  end
                else
  begin
  ret:=NVGetNetViewStatus(0);
  NVMinorVersion:=(ret shr 16)and $ff;
  NVMajorVersion:=(ret shr 24)and $ff;
  end;
  Result:=ret and $ffff;
  end;

  procedure TNetView.EventsHandler(msg:dword;wp:dword;lp:dword);
  begin
  case msg of
  NMNP_ALERT:
  begin
  if((wp and NVALERT_NETWATCHER)<>0)then
  begin
  if((wp and NVALERTMASK_CANCEL)=0) then
  begin
  if Assigned(FOnNetWatcherConnect)then FOnNetWatcherConnect(Self,lp,wp and (NVALERTMASK_NWBLACK or NVALERTMASK_NWWHITE));
  end else
  begin
  if Assigned(FOnNetWatcherDisconnect)then FOnNetWatcherDisconnect(Self,lp);
  end;
  end else if((wp and NVALERT_ALARMHOST)<>0)then
  begin
  if((wp and NVALERTMASK_CANCEL)<>0) then
  begin
  if Assigned(FOnHostAlertGoOnline)then FOnHostAlertClicked(Self,lp);
  end else if((wp and NVALERTMASK_HOSTDOWN)<>0) then
  begin
  if Assigned(FOnHostAlertGoOnline)then FOnHostAlertGoOffline(Self,lp);
  end else if((wp and NVALERTMASK_HOSTUP)<>0) then
  begin
  if Assigned(FOnHostAlertGoOnline)then FOnHostAlertGoOnline(Self,lp);
  end;
  end;
  end;
  NMNP_ACTION:
  begin
  if((wp and NVACTION_LIST)<>0) then
  begin
  if Assigned(FOnListEvent)then FOnListEvent(Self,lp,wp and (NVACTION_GETFROMNET or NVACTION_GETFROMFILE or NVACTION_RECHECK or NVACTION_RETRACE));
  end else if((wp and NVACTION_ACTIVATE)<>0) then
  begin
  if Assigned(FOnNetViewActivate)then FOnNetViewActivate(Self,lp<>WA_INACTIVE);
  end else if((wp and NVACTION_IMGEXPORT)<>0) then
  begin
  if Assigned(FOnVisualMapImageExported)then FOnVisualMapImageExported(Self,lp);
  end;
  end;
  WM_QUIT:
  begin
  SetEnableEventsHandling(false);
  if Assigned(FOnNetViewClose)then FOnNetViewClose(Self);
  end;
  end;

  end;

  function HandlerProc(msg:DWORD; wp:DWORD;lp:DWORD;tm:DWORD):dword;stdcall;
  var i:integer;
  begin
  EnterCriticalSection(crsc);
  for i:=0 to ObjList.Count-1 do
  if TNetView(ObjList.Items[i]).EnableEventsHandling then PostMessage(TNetView(ObjList.Items[i]).wnd,msg,wp,lp);
  LeaveCriticalSection(crsc);
  Result:=1;
  end;

  procedure TNetView.SetEnableEventsHandling(Value :boolean);
  begin
  if(Value and (not FEnableEventsHandling))then
  begin
  EnterCriticalSection(crsc);
  FEnableEventsHandling:=true;
  if HandlerEnablingCount=0 then NVSetEventHandlerProc(@HandlerProc);
  inc(HandlerEnablingCount);
  LeaveCriticalSection(crsc);
  end else if((not Value) and FEnableEventsHandling)then
  begin
  EnterCriticalSection(crsc);
  FEnableEventsHandling:=false;
  if(HandlerEnablingCount>0)then
  begin
  dec(HandlerEnablingCount);
  if HandlerEnablingCount=0 then NVSetEventHandlerProc(nil);
  end;
  LeaveCriticalSection(crsc);
  end;
  end;

function TNetView.Action(wp:cardinal;lp:cardinal):cardinal;
begin
Result:=NVAction(0,wp,lp);
end;


//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////HOST
//////////////////////////////////////////////////////////////////////////////////////////////////
function TNetView.GetHostIdByText(txt:string;flags:cardinal):cardinal;
begin
Result:=NVGetHostByTextA(0,pchar(txt),flags);
end;

function TNetView.GetHost(var hst:NVHOST;flags:cardinal):cardinal;
begin
Result:=NVGetHostA(0,@hst,flags);
end;

function TNetView.SetHost(var hst:NVHOST;flags:cardinal):cardinal;
begin
Result:=NVSetHostA(0,@hst,flags);
end;


function TNetView.DelHost(id:cardinal):cardinal;
var hst:nvhost;
    res:cardinal;
begin
zeromemory(@hst,sizeof(hst));
hst.id:=id;
res:=NVDelHostA(0,@hst);
Result:=res;
end;



function TNetView.GetMetaVar(id:cardinal;varname:string;var vardata:string):integer;
var i:integer;
    res:cardinal;
    BuffSize,OldBuffSize:dword;
    Buff:pchar;
begin
BuffSize:=256;
getmem(Buff,256);
res:=NVGetMetaVarA(0,id,pchar(varname),Buff,@BuffSize);
if(BuffSize>256)then
begin
freemem(Buff,256);
inc(BuffSize,256);OldBuffSize:=BuffSize;
getmem(Buff,BuffSize);
res:=NVGetMetaVarA(0,id,pchar(varname),Buff,@BuffSize);
setlength(vardata,BuffSize);
for i:=0 to BuffSize-1 do vardata[i+1]:=Buff[i];
freemem(Buff,OldBuffSize);
end else
begin
setlength(vardata,BuffSize);
if(BuffSize>0)then for i:=0 to BuffSize-1 do vardata[i+1]:=Buff[i];
freemem(Buff,256);
end;
Result:=res;
end;

function TNetView.SetMetaVar(id:cardinal;varname:string;vardata:string):integer;
begin
Result:=NVSetMetaVarA(0,id,pchar(varname),pchar(vardata),length(vardata));
end;
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////LIST
//////////////////////////////////////////////////////////////////////////////////////////////////
function TNetView.GetListIdByText(txt:string;flags:cardinal):cardinal;
begin
Result:=NVGetListByTextA(0,pchar(txt),flags);
end;
function TNetView.GetList(var lst:NVLIST):cardinal;
begin
Result:=NVGetListA(0,@lst);
end;
function TNetView.SetList(var lst:NVLIST):cardinal;
begin
Result:=NVSetListA(0,@lst);
end;
function TNetView.DelList(id:cardinal):cardinal;
var lst:lpNVLIST;
begin
lst.id:=id;
Result:=NVSetListA(0,@lst);
end;
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////LINE
//////////////////////////////////////////////////////////////////////////////////////////////////
function TNetView.GetLine(var ln:NVLINE):integer;
begin
Result:=NVGetLineA(0,@ln);
end;
function TNetView.SetLine(var ln:NVLINE):integer;
begin
Result:=NVSetLineA(0,@ln);
end;
function TNetView.DelLine(ind:integer):integer;
var ln:NVLINE;
begin
ln.index:=ind;
Result:=NVDelLineA(0,@ln);
end;
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////AREA
//////////////////////////////////////////////////////////////////////////////////////////////////
function TNetView.GetArea(var ar:NVAREA):cardinal;
begin
Result:=NVGetAreaA(0,@ar);
end;
function TNetView.SetArea(var ar:NVAREA):cardinal;
begin
Result:=NVSetAreaA(0,@ar);
end;
function TNetView.DelArea(id:cardinal):cardinal;
var ar:NVAREA;
begin
ar.id:=id;
Result:=NVDelAreaA(0,@ar);
end;




procedure Register;
begin
  RegisterComponents('KillProg', [TNetView]);
end;


begin
ObjList:=TList.Create;
nvapidll:=LoadLibrary('nvapi.dll');
if nvapidll<>0 then
begin
NVGetNetViewStatus:=GetProcAddress(nvapidll,'NVGetNetViewStatus');
NVSetEventHandlerProc:=GetProcAddress(nvapidll,'NVSetEventHandlerProc');

NVAction:=GetProcAddress(nvapidll,'NVAction');
NVGetHostByTextA:=GetProcAddress(nvapidll,'NVGetHostByTextA');
NVGetHostA:=GetProcAddress(nvapidll,'NVGetHostA');
NVSetHostA:=GetProcAddress(nvapidll,'NVSetHostA');
NVDelHostA:=GetProcAddress(nvapidll,'NVDelHostA');
NVGetMetaVarA:=GetProcAddress(nvapidll,'NVGetMetaVarA');
NVSetMetaVarA:=GetProcAddress(nvapidll,'NVSetMetaVarA');

NVGetListByTextA:=GetProcAddress(nvapidll,'NVGetListByTextA');
NVGetListA:=GetProcAddress(nvapidll,'NVGetListA');
NVSetListA:=GetProcAddress(nvapidll,'NVSetListA');
NVDelListA:=GetProcAddress(nvapidll,'NVDelListA');

NVGetLineA:=GetProcAddress(nvapidll,'NVGetLineA');
NVSetLineA:=GetProcAddress(nvapidll,'NVSetLineA');
NVDelLineA:=GetProcAddress(nvapidll,'NVDelLineA');

NVGetAreaA:=GetProcAddress(nvapidll,'NVGetAreaA');
NVSetAreaA:=GetProcAddress(nvapidll,'NVSetAreaA');
NVDelAreaA:=GetProcAddress(nvapidll,'NVDelAreaA');
end;
HandlerEnablingCount:=0;
InitializeCriticalSection(crsc);
end.

