unit nvplugn;
interface
uses windows,messages,classes;
//**************************************
//*NetView plug-ins delphi module v2.80*
//*     (c)Killer{R} 21.04.2004 Rev F  *
//**************************************

//------------------------------------------------
//NMNP_HOSTMSG
//Sent by NetView to plug-ins and scripts when
//user double clicked on the host with specified
//and enabled "hostmsg://NNN" command on advenced page
//of host's edition dialog. wParam - user specified
//number NNN. lParam - host's id.


//------------------------------------------------
//NMPN_GETRESLIST
//Used to get NETBIOS or FTP resourcelist of specified hostname
//NETBIOS and FTP settings determined by general NetView's settings
//and host's individual settings
//wParam=0; - to get NETBIOS resources (if enabled by settings)
//wParam=1; - to get FTP resources (if enabled by settings)
//lParam points to NVRESLIST structure. If thereis not enough buffer length
//to place result message returns 2 and set buflen field to neccessary length.
//In case of success returns 1. By the way if hosts has no resources or if network
//error occured message returns 1 to but resourcelist contains only character '\1'
//If internal NetView error occured returns 0


//------------------------------------------------
//NMPN_CALLBACK
//Used to set plugins callback functions to handle event of recheck host with
//disabled default rechecks or to make some work on every host's SETSTATE event
//lParam points to such callback function :
//LRESULT CALLBACK NVCallBackProc(DWORD EventCode, DWORD ObjId, void *Reserved)
//EventCode - event code: NVCB_CUSTOM_RECHECK or NVCB_PRE_SETSTATE (see below)
//ObjId     - host's id
//function must return 1
//Flags in wParam:
const NVCB_CUSTOM_RECHECK=$0001;//to enable notifies on recheck of hosts
                                        ///with disabled default recheck mechanism
const NVCB_PRE_SETSTATE=$0002;  //to enable notifies just before hosts setstate
const NVCB_REMOVECALLBACK=$1000;//use to remove callback function or disable some events

//------------------------------------------------
//NMPN_NVCTL
//wParam=0;lParam=0 - shows and activates main NetView window
//wParam=1;lParam points to MSG structure. Message in MSG will
// be broadcasted to all currently loaded plugins

//------------------------------------------------
//NMPN_PLUGINEX -used to connect external process as plugin
//wParam
//0 to query NetView info by external process
//1 to remove thread from NetView's plugins list
//2 to add thread to NetView's plugins list
//lParam points to NVPLUGININFO structure
//process must allocate this structure
//process must allocate NVPLUGINGOINFO structure and set pointer to it in NVPLUGININFO.goinfo
//process nust allocate and free all structrures in address space of NetView, by using
//VirtualAllocEx/VirtualFreeEx, read and write memory by ReadProcessMemory/WriteProcessMemory
//process must correctly remove itself from plugins list on exiting and when received WM_QUIT
//from NetView to avoid blocking NetView on exit

//------------------------------------------------
//NetView sets this flags in NMNP_ALERT as wParam
//lParam depends on alert type
const NVALERT_NETWATCHER=$00000001;  //NetWatcher detected user connection, lParam - host id or NULL
const NVALERT_ALARMHOST=$00000002;   //Alarm host in host list goes up or down, lParam - host id or NULL
const NVALERT_TERMINAL=$00000003;    //Terminal accepted client in server mode, lParam - host id or NULL
const NVALERT_REDIRECTOR=$00000004;  //Redirector accepted client, lParam - host id or NULL
const NVALERT_IPLOGGER=$00000005;    //IP logger detected activity or flood atack,
const NVALERT_NETSEARCHER=$00000006; //NetSearcher event send on end searching
const NVALERTMASK_CANCEL=$00040000;  //bitmask. If set continious event has been finished.(Alarmhost goes down, NetWatcher - user disconnected, Terminal, Redirector - client disconnected, IP logger - no portlistener activity, NVALERT_ALARMHOST - user clicks on alarmed host)
const NVALERTMASK_NWBLACK=$00010000; //NVALERT_NETWATCHER
const NVALERTMASK_NWWHITE=$00020000; //masks
const NVALERTMASK_NWSKIP=$00080000; //
const NVALERTMASK_ILLIST=$00010000;  ///////
const NVALERTMASK_ILICMP=$00020000;  //NVALERT_IPLOGGER
const NVALERTMASK_ILSYN=$00080000;   //masks
const NVALERTMASK_ILUDP=$00100000;   ///////
const NVALERTMASK_HOSTUP=$00010000;  //NVALERT_ALARMHOST
const NVALERTMASK_HOSTDOWN=$00020000;//masks


//------------------------------------------------
//use with NMPN_OBJECT
//lParam points to NVHOST, NVLIST or NVLINE structure
//wParam:

const NVOBJ_SELECTED=$10000;  //Use with NVOBJ_GETHOST
const NVOBJ_FORCENEW=$20000;  //Use with NVOBJ_HOSTBYTEXT and NVOBJ_LISTBYTEXT
const NVOBJ_HOSTNOIP=$40000;  //Use with NVOBJ_HOSTBYTEXT|NVOBJ_FORCENEW to add host
                               //with empty IP preventing any resolving
                               //you can add host with random name and empy IP then
                               //make it static and set true name and IP
const NVOBJ_GETHOST=$00001;   //set id to NULL to get first host
                               ///selected hosts will be returned if NVOBJ_SELECTED
const NVOBJ_SETHOST=$00002;   //set id to NULL to add new host
                               ///Note that if exists host with same name or IP
                               ///it will be rescanned and returned


const NVOBJ_DELHOST=$00004;
const NVOBJ_HOSTBYTEXT=$00008;//lp points to hostname or ip address. Message returns host id
                               ///if NVOBJ_FORCENEW specified new host will be created
//
const NVOBJ_GETLIST=$00010;   //set id to zero to get first list
const NVOBJ_SETLIST=$00020;   //set id to zero to create new list.
                               ///Note that if exists list with same name it will be returned
const NVOBJ_DELLIST=$00040;   //lParam represents list id
const NVOBJ_LISTBYTEXT=$00080;//lParam points to mapname, can be used with NVOBJ_FORCENEW
                               ///Message returns list id
//
const NVOBJ_GETLINE=$00100;   //Set index field in NVLINE structure.
                               ///Message result equals total line count.
const NVOBJ_SETLINE=$00200;   //Set index field in NVLINE structure. Set Index to -1 to add new line.
                               ///Message result equals total line count after.
const NVOBJ_DELLINE=$00400;   //Set lParam to index of line to be deleted.
                               ///Message result equals total line count after.
//
const NVOBJ_GETAREA=$00800;//set id to zero to get first area
                           //return id if success or 0 if error occured
const NVOBJ_SETAREA=$01000;//set id to zero to create new area if there is no area with the same name on the same map
                           ///Note that if exists area with same name on specified map it will be returned
                           //return id if success or 0 or -1 if error occured
const NVOBJ_DELAREA=$02000;//lParam represents area's id
                           //return 1 if success or 0 if error occured

//------------------------------------------------



//use with NMPN_MENU
//wParam      NVMENUACTION_SET|NVMENUACTION_DEL
//lParam      LPNVMENUINFO  |DWORD id
const NVMENUACTION_SET=0;    //set id to zero to create new menu item and it's id
                             //will be returned
const NVMENUACTION_DEL=1;
const NVMENUACTION_SPLIT=2;
const NVMENUFLAG_MAIN=    $01;//Menu item will be appeared in Plug-ins submenu. This flag only used when creating non-submenu item.
const NVMENUFLAG_CONTEXT= $02;//Menu item will be appeared in context menu. This flag only used when creating non-submenu item.
const NVMENUFLAG_TRAY=    $04;//Menu item will be appeared in tray icon popup menu. This flag only used when creating non-submenu item.
const NVMENUFLAG_DISABLED=$08;//Menu item will be appeared as disabled
const NVMENUFLAG_CHECKED= $10;//Menu item will be appeared as checked
const NVMENUFLAG_SORTED=  $20;//Menu item will be added at sorted position
//------------------------------------------------
//use with NMPN_METAVAR
//wParam = {NVMETAVAR_GET,NVMETAVAR_SET}
//lParam LPNVMETAVAR
const NVMETAVAR_GET=0;
//return 1 if success
//return 0 if fail
//return 2 if vallen too small to acomodate all data. Vallen on return equals data length
const NVMETAVAR_SET=1;
//return 1 if success
//return 0 if fail
const NVMETAVAR_USEID=2;
//Bit flags, is set then use "id" instead of "name" field of "host" union in NVMETAVAR structure


//------------------------------------------------
//NMPN_ACTION and NMNP_ACTION
//bitmask for wParam

//group flags
const NVACTION_GETFROMNET = $01;//!use only when NVACTION_LIST specified
const NVACTION_GETFROMFILE= $02;//!use only when NVACTION_LIST specified
                                 ///lParam contains (char *) - path to LMHOSTS
                                 ///to import or NULL - default will be used
const NVACTION_RECHECK    = $08;//if NVACTION_LIST not specified
                                 ///lParam contains ListView host id
                                 ///otherwise list id or NULL to recheck all lists
const NVACTION_RETRACE    = $1000;//if NVACTION_LIST not specified lParam contains list id or hostid

const NVACTION_CLEARLIST  = $2000;//lParam contains id of list to be deleted or NULL to clear entire list

const NVACTION_ACTIVATE   = $8000;//Main netview window status changed lParam
                                   ///equals wParam in WM_ACTIVATE message sent
                                   ///to main window by system

const NVACTION_MENUPOPUP  = $10000;//NetView sends this message when plug-ins menu, tray menu or context menu popups
                                    //lParam equals NVMENUFLAG_MAIN, NVMENUFLAG_CONTEXT or NVMENUFLAG_TRAY
                                    //plugin can use this notification to dynamically enable/disable its menu items

const NVACTION_LIST       = $20;  //if not set means single host action

//single flag
const NVACTION_OPEN       = $10;//use only when NVACTION_LIST not specified
                                 ///lParam contains host item id
//single flag
const NVACTION_SAVELMHOSTS= $100;//use to save entire hostlist to specified file
                                  ///lParam contains pointer to file path\name
                                  ///or NULL - default LMHOSTS will be saved
                                  ///!All other flags should be not set

//single flag

const NVACTION_SETSTATE =  $400;//lParam=0 Resets current state of NetView:
                                 ///lParam=hostid - redraws host on list

const NVACTION_SETTINGS =  $800;//lParam=0 - notifies plug-in that global settings has been changed by user

//single flag
const NVACTION_EDIT     =  $20000;//lParam contains host id to edit
                                   //return host id or 0 if edit cancelled

const NVACTION_IMGEXPORT=   $40000;//lParam contains exported list id
                                    //this message can be sent by plugin to initiate export
                                    //returns 1 if initiate export succed
                                    //NetView sends this message when list has been exported

//followed bitmasks sets by NMNP_ACTION in wParam with all other NVACTION_ bitmasks
//only when NVACTION_LIST not set (single recheck/open host) lParam in this case
//represents hostitem id or NULL if no item associated
const NVACTION_RESULTONLINE=  $40;
const NVACTION_RESULTOPENED=  $80;
//------------------------------------------------

//***Messages
//plugin->netview main window-----------(Use SendMessage)
const NMPN_MENU=WM_USER+$401;
const NMPN_METAVAR=WM_USER+$402;
const NMPN_ACTION=WM_USER+$403;
const NMPN_GETSHARELIST=WM_USER+$404;
const NMPN_GETRESLIST=WM_USER+$405;
const NMPN_OBJECT=WM_USER+$407;
const NMPN_PLUGINEX=WM_USER+$409;
const NMPN_CALLBACK=WM_USER+$40A;
const NMPN_NVCTL=WM_USER+1215;
//netview->plugin main thread-----------(Used PostThreadMessage)
const NMNP_ACTION=WM_USER+$403;
const NMNP_HOSTMSG=WM_USER+$404;
const NMNP_ALERT=WM_USER+$406;


type NVHOST=packed record
hostname:array[1..128]of char;
hostip:array[1..64]of char;
id:DWORD;                           //set this value to zero to get first host.
nextid:DWORD ;
color:DWORD;                        //item color in list
res:array[1..4]of DWORD;
selected:bool;
end;

type NVLIST=packed record
name:array[1..128]of char;
theme:array[1..128]of char;
ltype:array[1..128]of char;
llength:array[1..128]of char;
lspeed:array[1..128]of char;
lnote:array[1..128]of char;
w:array[1..32]of cardinal;
id:DWORD;
nextid:DWORD;
reserved:array[1..128]of dword;
end;

type NVLINE=packed record
index:integer;
x:array[1..32]of integer;
y:array[1..32]of integer;///
nodes:integer;//nodes count
color:dword;
flags:integer;
width:integer;
ltype:array[1..128]of char;
llength:array[1..128]of char;
lspeed:array[1..128]of char;
lnote:array[1..128]of char;
mapname:array[1..128]of char;
reserved:array[1..128]of dword;
end;
type nvrect=packed record
left:integer;
top:integer;
right:integer;
bottom:integer;
end;
type NVAREA=packed record
bounds:nvrect;
color:DWORD;
hint:array[1..256] of char;
name:array[1..256] of char;
mapname:array[1..128] of char;
id:DWORD;
nextid:DWORD;
reserved:array[1..128] of dword;
end;
type NVMENUINFO=packed record
id:DWORD;       //After NVMENUACTION_SET call with id=0 id
                //will be contain menu handle wich can be
                //used in subsequent calls NVMENUACTION_SET
                //or NVMENUACTION_DEL
msg:DWORD;      //Message to send to plug-in's thread on click
tid:DWORD;      //ThreadId to wich send message
icon:hicon;     //HANDLE to icon or NULL
parentid:DWORD; //id of the parent menu item or NULL.
                //If it is not NULL NVMENUFLAG_MAIN,NVMENUFLAG_CONTEXT,NVMENUFLAG_TRAY
                //doesn't matter when creating menu item
txt:array[1..64]of char;//item text
flags:DWORD;    //see NVMENUFLAG_######
reserved:array[1..256]of byte;//set to zero
end;
type NVMETAVAR=packed record
host:record
    case integer of
      0: (name: array[1..128]of char);
      1: (id:dword);
  end;

varname:array[1..64]of char;  //variable name. Cannot contain characters
                       //'#', '$', #0, #13
vallen:integer;        //length of the variable data
val:array[1..1]of char;//variable data. Cannot contain characters
                       //'#', '$', #0, #13
end;

type NVVERSION=packed record
hi:byte;
lo:byte;
end;
type NVPLUGINGOINFO=packed record
nvwnd:HWND;             //NetView's plug-in messages processing window hanle
                        //use as the 1st parameter in SendMessage
nvmainwnd:HWND;         //NetView's main window hanle
inipath:pchar;          //path to NetView .ini file
exepath:pchar;          //path and name of NetView.exe file
reserved:array[1..164]of byte;
end;

type NVPLUGININFO=packed record
nvver:NVVERSION;//NetView sets this field to it's version
retver:NVVERSION;//Plug-in should sets this field to it's version
plname:array[1..64]of char; //plug-in name
retstr:array[1..128]of char;//plug-in description
goinfo:^NVPLUGINGOINFO; //used only with NMPN_PLUGINEX. External thread must allocate this structure
tid:DWORD;               //used only with NMPN_PLUGINEX. External thread ID.
reserved:array[1..244]of byte;      //set to zero
end;
type lpNVPLUGININFO=^NVPLUGININFO;
type lpNVPLUGINGOINFO=^NVPLUGINGOINFO;
type lpNVMETAVAR=^NVMETAVAR;
type lpNVMENUINFO=^NVMENUINFO;
type lpNVLIST=^NVLIST;
type lpNVHOST=^NVHOST;
type lpNVAREA=^NVAREA;
procedure strcpy(dest:pchar;src:string);

implementation
//typedef DWORD (WINAPI *NVPLUGINGETINFO)(LPNVPLUGININFO);//export name NVPluginGetInfo

//typedef DWORD (WINAPI *NVPLUGINGO)(LPNVPLUGINGOINFO);   //export name NVPluginGo

//typedef DWORD (WINAPI *NVPLUGINCONFIG)(void *reserved); //export name NVPluginConfig
                                                          //plugin can don't export this
procedure strcpy(dest:pchar;src:string);
var i:integer;
begin
for i:=1 to length(src) do
begin
dest[i-1]:=src[i];
end;
dest[length(src)]:=chr(0);
end;
end.
